var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Ed25519Signer_privateKey;
import { ed25519 } from "@noble/curves/ed25519";
import { createSignature } from "@canvas-js/signed-cid";
export class Ed25519Signer {
    constructor(privateKey = ed25519.utils.randomPrivateKey()) {
        _Ed25519Signer_privateKey.set(this, void 0);
        __classPrivateFieldSet(this, _Ed25519Signer_privateKey, privateKey, "f");
        this.publicKey = ed25519.getPublicKey(__classPrivateFieldGet(this, _Ed25519Signer_privateKey, "f"));
    }
    sign(message) {
        return createSignature("ed25519", __classPrivateFieldGet(this, _Ed25519Signer_privateKey, "f"), message);
    }
}
_Ed25519Signer_privateKey = new WeakMap();
